ViewModels/MessageModels/MessageViewModel.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

namespace Backend_Task2.ViewModels
{
    public class MessageViewModel
    {
        public int Id { get; set; }

        public string Text { get; set; }

        public DateTime Created { get; set; }

        public DateTime? Modified { get; set; }

        public int TopicID { get; set; }

        public List<AttachmentViewModel> Attachments { get; set; }
    }
}

Controllers/MessageController.cs
using Microsoft.AspNetCore.Mvc;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;
using Backend_Task2.ViewModels;
using Backend_Task2.Forum.Models;
using Backend_Task2.Forum;
using Microsoft.AspNetCore.Hosting;
using Microsoft.EntityFrameworkCore;
using Backend_Task3.Services;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Identity;

namespace Backend_Task2.Controllers
{
    [Authorize]
    public class MessageController : Controller
    {
        private readonly ApplicationDbContext _context;
        private readonly IMessageService _service;
        private readonly UserManager<AppUserModel> _userManager;


        public MessageController(ApplicationDbContext context, IMessageService service, UserManager<AppUserModel> userManager)
        {
            _context = context;
            _service = service;
            _userManager = userManager;
        }

        // GET: MessageController/Create
        public ActionResult Create(int id)
        {
            return View(new MessageCreateViewModel { TopicID = id});
        }

        // POST: MessageController/Create
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Create(MessageCreateViewModel newMessage)
        {
            try
            {
                if (!ModelState.IsValid)
                {
                    return View(newMessage);
                }

                var user = await _userManager.FindByNameAsync(User.Identity.Name);

                if (user is null)
                {
                    throw new UnauthorizedAccessException($"User with the name {User.Identity.Name} was not found");
                }

                newMessage.Created = DateTime.Now;

                var topicID = -1;

                if (TempData["ForumID"] != null)
                {
                    topicID = (int)TempData["TopicID"];
                }

                await _service.CreateAsync(newMessage, user);

                TempData["SuccessMessage"] = "Сообщение успешно отправлено.";

                if (topicID > -1)
                {
                    return RedirectToAction("Details", "Topic", new { id = topicID });
                }
                else
                {
                    return RedirectToAction("Index", "Forum");
                }
            }
            catch (UnauthorizedAccessException)
            {
                ViewBag.ErrorMessage = "Вы не вошли в аккаунт или он был удалён. Действие отменено.";
                return View(newMessage);
            }
            catch (Exception)
            {
                ViewBag.ErrorMessage = "Что-то пошло не так, попробуйте позднее.";
                return View(newMessage);
            }
        }

        // GET: MessageController/Edit/5
        public async Task<ActionResult> Edit(int id)
        {
            var messageEditView = await _service.GetForEditAsync(id);


            if (messageEditView is null)
            {
                TempData["ErrorMessage"] = "Неправильный запрос. Сообщение не существует или уже удалено.";
                return RedirectToAction("Index", "Forum");
            }

            return View(messageEditView);
        }

        // POST: MessageController/Edit/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Edit(MessageEditViewModel messageView)
        {
            try
            {
                if (!ModelState.IsValid) 
                {
                    return View(messageView);
                }

                var user = await _userManager.FindByNameAsync(User.Identity.Name);

                if (user is null)
                {
                    throw new NullReferenceException($"User with the name {User.Identity.Name} was not found");
                }

                int? topicID = null;

                if (TempData["ForumID"] != null)
                {
                    topicID = (int)TempData["TopicID"];
                }

                await _service.EditAsync(messageView, User);

                TempData["SuccessMessage"] = "Сообщение успешно изменено.";

                if (topicID != null)
                {
                    return RedirectToAction("Details", "Topic", new { id = topicID });
                }
                else
                {
                    return RedirectToAction("Index", "Forum");
                }
            }
            catch (NullReferenceException)
            {
                ViewBag.ErrorMessage = "Вы не вошли в аккаунт или он был удалён. Действие отменено.";
                return View(messageView);
            }
            catch (UnauthorizedAccessException)
            {
                ViewBag.ErrorMessage = "У вас недостаточно прав для изменения сообщения.";
                return View(messageView);
            }
            catch (KeyNotFoundException)
            {
                ViewBag.ErrorMessage = "Неправильный запрос. Сообщение не существует или было удалено.";
                return View(messageView);
            }
            catch (Exception)
            {
                ViewBag.ErrorMessage = "Что-то пошло не так, попробуйте позднее.";
                return View(messageView);
            }
        }

        // GET: MessageController/Delete/5
        public async Task<ActionResult> Delete(int id)
        {
            var messageView = await _service.GetForDeleteAsync(id);


            if (messageView is null)
            {
                TempData["ErrorMessage"] = "Неправильный запрос. Сообщение не существует или уже удалено.";
                return RedirectToAction("Index", "Forum");
            }

            return View(messageView);
        }

        // POST: MessageController/Delete/5
        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<ActionResult> Delete(MessageViewModel messageView)
        {
            try
            {
                int? topicID = null;

                if (TempData["ForumID"] != null)
                {
                    topicID = (int)TempData["TopicID"];
                }

                var user = await _userManager.FindByNameAsync(User.Identity.Name);

                if (user is null)
                {
                    throw new NullReferenceException($"User with the name {User.Identity.Name} was not found");
                }

                await _service.DeleteAsync(messageView, User);

                TempData["SuccessMessage"] = "Сообщение успешно удалено.";

                if (topicID != null)
                {
                    return RedirectToAction("Details", "Topic", new { id = topicID });
                }
                else
                {
                    return RedirectToAction("Index", "Forum");
                }
            }
            catch (NullReferenceException)
            {
                ViewBag.ErrorMessage = "Вы не вошли в аккаунт или он был удалён. Действие отменено.";
                return View(messageView);
            }
            catch (KeyNotFoundException)
            {
                ViewBag.ErrorMessage = "Неправильный запрос. Сообщение не существует или было удалено.";
                return View(messageView);
            }
            catch (UnauthorizedAccessException)
            {
                ViewBag.ErrorMessage = "У вас недостаточно прав для изменения сообщения.";
                return View(messageView);
            }
            catch (Exception)
            {
                ViewBag.ErrorMessage = "Что-то пошло не так, попробуйте позднее.";
                return View(messageView);
            }
        }
    }
}

Views/Message/Create.cshtml
@model MessageCreateViewModel

<form asp-action="Create" asp-controller="Message" type="post" enctype="multipart/form-data">

    <div asp-validation-summary="ModelOnly" class="text-danger"></div>
    <input asp-for="TopicID" type="hidden" />

    <div class="form-group">
        <label asp-for="Text">Текст сообщения</label>
        <input asp-for="Text" type="text" />
        <span asp-validation-for="Text" class="text-danger"></span>
    </div>
    <div class="form-group">
        <label asp-for="Attachments">Картиночки</label>
        <input asp-for="Attachments" type="file" id="files" multiple onchange="checkUploadSize()" />
        <span asp-validation-for="Attachments" class="text-danger"></span>
    </div>

    <div style="display: flex; gap: 20px;">
        <button type="submit" class="btn btn-success">Отправить сообщение</button>

        @{
            if (@TempData.Peek("TopicID") != null)
            {
                <a asp-controller="Topic" asp-action="Details" asp-route-id="@TempData.Peek("TopicID")">Вернуться к теме</a>
            }
        }
    </div>
</form>

<script type="text/javascript">

    const checkUploadSize = () => {
        const uploadedFiles = document.getElementById('files');

        if (uploadedFiles.files.length > 4) {
            alert("Максимальное количество файлов для одного сообщения - 4");
            uploadedFiles.value = null;
            return;
        }

        for (let i = 0; i < uploadedFiles.files.length; i++) {
            const image = uploadedFiles.files[i];

            console.log(image);

            if (image.type !== "image/jpeg" && image.type !== "image/png") {
                alert("Загружать можно только изображения формата png/jpg/jpeg");
                uploadedFiles.value = null;
                return;
            }

            if (image.size > 8388608) {
                alert("Максимальный размер одного изображения - 8МБ");
                uploadedFiles.value = null;
                return;
            }

        }
    }
</script>

Views/Message/Delete.cshtml
@model MessageViewModel

<h2>Вы уверены, что хотите удалить данное сообщение?</h2>

<p>Текст сообщения - @Model.Text</p>

<form asp-action="Delete" asp-controller="Message" method="post">
    <div style="display: flex; gap: 20px;">
        <input type="submit" value="Delete" class="btn btn-danger">
        @{
            if (@TempData.Peek("TopicID") != null)
            {
                <a asp-controller="Topic" asp-action="Details" asp-route-id="@TempData.Peek("TopicID")">Вернуться к теме</a>
            }
        }
    </div>
</form>

Views/Message/Edit.cshtml
@model MessageEditViewModel

<form asp-action="Edit" asp-controller="Message" method="post">

    <input asp-for="Id" type="hidden" />

    <div class="form-group">
        <label asp-for="Text"></label>
        <input asp-for="Text" type="text" class="form-control" />
        <span asp-validation-for="Text"></span>
    </div>

    <div style="display: flex; gap: 20px;">
        <button class="btn btn-success" type="submit">Сохранить</button>

        @{
            if (@TempData.Peek("TopicID") != null)
            {
                <a asp-controller="Topic" asp-action="Details" asp-route-id="@TempData.Peek("TopicID")">Вернуться к теме</a>
            }
        }
    </div>
</form>